poj 2796 Feel Good - Monotonic Stack


Description
Bill is developing a new mathematical theory for human emotions. His recent investigations are dedicated to studying how good or bad days influent people's memories about some period of life.

A new idea Bill has recently developed assigns a non-negative integer value to each day of human life.

Bill calls this value the emotional value of the day. The greater the emotional value is, the better the daywas. Bill suggests that the value of some period of human life is proportional to the sum of the emotional values of the days in the given period, multiplied by the smallest emotional value of the day in it. This schema reflects that good on average period can be greatly spoiled by one very bad day.

Now Bill is planning to investigate his own life and find the period of his life that had the greatest value. Help him to do so.

https://blog.csdn.net/ACMore_Xiong/article/details/52326755
单调栈: 顾名思义就是在入栈时遵循单调原则,可以求出一个元素向左(或向右)所能扩展到的最大长度,并不是说在这一段区间内是单调的,而是保证在该区间内该元素一定是最大或最小;
单调栈主要是大家要自己枚举,需要找到每个元素最左能扩展到那 ,最优能扩展到那,当然最小的是你枚举的那个元素。
我们有如下的性质:
1. 如果当前元素大于前一元素,那么前一元素能扩展到当前元素,同时说明前面的数对当前元素来说是没有贡献的
2。如果当前元素等于前一元素,那么前一元素也能扩展到当前元素,同时说明前面的元素是可以被忽略的
3。如果当前元素小于前一个元素,那么前面至少有一个元素不能扩展到当前元素的位置,那么这些不能继续扩展的元素的存在显的没有什么意义了,不妨删除它。
我们得到两条结论:
1。一旦一个元素已经进入栈中那么这个元素向左扩展的位置就确定下来了.
2。一旦一个元素出栈被弹出栈,那么这个元素向右扩展的位置也确定下来了.


https://blog.csdn.net/u010885899/article/details/49148025
实际上这个题目就是要对每一个节点进行扩展,这样扩展的话,复杂度是O(n^2)。减少时间复杂度要用单调栈,单调栈处理的问题就是对每一个节点进行扩展的问题,这个题目要维护的是一个单调递减栈,即从栈顶元素到栈底元素,值是单调递减的,即栈顶元素的值始终是栈的最大值。然后每一个值有属于自己的区间,这个区间目的是为了记录之后的元素向前延伸的用处。

向后延伸就靠从1到n扫描元素,(维护单调递增栈)这样当扫描的元素大于栈顶元素时,直接入栈。

当扫描的元素等于栈顶元素时,不记录,只将区间延伸到后面。

当扫描的元素小于栈顶元素时,这时要计算栈内当前的值。因为扫描的元素时小于栈顶元素的,要求的是一个区间的最小值,所以栈内那些大于该元素的值你会发现没有用处了,只需要将它们的那些区间留下来就对了,这就是向前扩展。

拿题目的sample举例子:

3 1 6 4 5 2



一开始每一个数都有自己的区间:

3(1,1)  1(2,2)  6(3,3)  4(4,4)  5(5,5)  2(6,6)  -1(7,7)后面加一个最小值,为了最后计算栈内元素使用。

先是3入栈。栈内元素 3(1,1)

1<3,首先计算一下栈内元素的值,记录下来。然后要把栈内大于1的全部弹出来,但是把它们的区间留下,栈内就变成了1(1,2)。实际上此时就会知道(1,2)这段区间之内的最小值是1。

6>1,直接入栈,栈内元素变为1(1,2),6(3,3)。

4<6,将6弹出,弹出之前计算值。然后栈内就变为1(1,2),4(3,4)。

5>4,直接入栈。栈内元素是1(1,2),4(3,4),5(5,5)。会发现因为5没有办法向前扩展了所以会知道5只能够在(5,5)的区间内最小,所以说站内元素是在自己区间的左端点与栈顶元素的右端点,这段区间之内满足着最小值的关系。1是在(1,5)这段区间内最小,4是在(3,5)这段区间内最小。这些值都会在碰到扫描的元素小于该元素时计算,记录下来,就是这样单调栈完成了对每一个元素进行左右扩展的目的。

2<5,2<4。要把5(5,5) 4(3,4)分别弹出,它们走之前要计算各自区间的值。

最后是-1,目的就是要将栈内所有元素弹出,计算每一个元素左右扩展的值。



给你n个数的数组arr[n]。要你找到一个L和R是的。(arr[L]+.....+arr[R])*arr[k]的值最大。arr[k]为L->R的数的最小值。
思路:
很好的单调队列题。只要理解单调队列(升序)的特性。
1,如果刚入队完第j个元素。单调队列里剩下的元素(下标i)一定是[i,j]的最小值。因为如果不是最小的话就会被后面入队的值覆盖。
2,在j入队的过程中如果停在k(原数组下标)的后面说明arr[k]比arr[j]小。说明。arr[j]是除了arr[k]是[k,j]间最小的。即[k+1,j]最小的。
3,在j入队的过程中如果队里的i(原数组下标)出队。说明arr[i]是[i,j-1]间最小的。因为一加入j它就被出队了。说明它已不是最小。
Code from http://blog.himdd.com/archives/1588
11int main()
12{
13    int n;
14    while(~scanf("%d",&n))
15    {
16        for(int i=1;i<=n;i++)
17        {
18            scanf("%d",&elem[i]);
19            sum[i]=sum[i-1]+elem[i];
20        }
21        elem[n+1]=-1;
22        long long ans=-1,tmp;
23        int top=0,l,r;
24        for(int i=1;i<=n+1;i++)
25        {
26            while(top!=0&&elem[st[top]]>elem[i])
27            {
28                tmp=elem[st[top]]*(sum[i-1]-sum[st[top-1]]);//栈顶元素是序列的最小元素
29                if(ans<tmp)
30                {
31                    ans=tmp;
32                    l=st[top-1]+1;
33                    r=i-1;
34                }
35                top--;
36            }
37            top++;
38            st[top]=i;
39        }
40        printf("%lld\n%d %d\n",ans,l,r);
41    }
42

43}
  1. const int INF=0x3f3f3f3f;  
  2. const double eps=1e-8;  
  3. const double PI=acos(-1.0);  
  4. const int maxn=100010;  
  5. typedef __int64 ll;  
  6. int q[maxn];  
  7. int le[maxn],ri[maxn],em[maxn];  
  8. int head,tail;  
  9. ll sum[maxn];  
  10. int main()  
  11. {  
  12.     int n,i,ans;  
  13.     ll mv,tt;  
  14.   
  15.     sum[0]=0;  
  16.     em[0]=-1;  
  17.     while(~scanf("%d",&n))  
  18.     {  
  19.         em[n+1]=-1;//为了清空队列  
  20.         for(i=1;i<=n;i++)  
  21.         {  
  22.             scanf("%d",&em[i]);  
  23.             sum[i]=sum[i-1]+em[i];  
  24.         }  
  25.         head=tail=0;  
  26.         q[tail++]=0;  
  27.         for(i=1;i<=n+1;i++)  
  28.         {  
  29.             while(head<tail&&em[i]<em[q[tail-1]])  
  30.             {  
  31.                 ri[q[tail-1]]=i-1;//被出队右边界就可以确定  
  32.                 tail--;  
  33.             }  
  34.             le[i]=q[tail-1]+1;//可以确定左边界  
  35.             q[tail++]=i;  
  36.         }  
  37.         mv=-1;  
  38.         for(i=1;i<=n;i++)  
  39.         {  
  40.             tt=(sum[ri[i]]-sum[le[i]-1])*em[i];  
  41.             if(tt>mv)  
  42.                 mv=tt,ans=i;  
  43.         }  
  44.         printf("%I64d\n%d %d\n",mv,le[ans],ri[ans]);  
  45.     }  
  46.     return 0;  
http://alwa.info/2013/09/16/POJ%202796%20Feel%20Good%20(%E5%8D%95%E8%B0%83%E9%98%9F%E5%88%97)/
http://tonyfang.is-programmer.com/posts/204255.html
往两边单调栈求出第一个比当前小的数的位置。
    scanf("%d", &n);
    for (int i=1; i<=n; ++i) {
        scanf("%d", &a[i]);
        s[i] = s[i-1] + a[i];
    }
    for (int i=1; i<=n; ++i) {
        if(a[i] > st[stn]) {
            st[++stn] = a[i];
            last[i] = stw[stn-1];
            stw[stn] = i;
        } else {
            while(a[i] <= st[stn] && stn != 0) --stn;
            if(stn == 0) last[i] = 0;
            else last[i] = stw[stn];
            st[++stn] = a[i];
            stw[stn] = i;
        }
    }
    stn = 0;
    memset(st, 0, sizeof(st));
    memset(stw, 0, sizeof(stw));
    for (int i=n; i>=1; --i) {
        if(a[i] > st[stn]) {
            st[++stn] = a[i];
            next[i] = stw[stn-1];
            stw[stn] = i;
        } else {
            while(a[i] <= st[stn] && stn != 0) --stn;
            if(stn == 0) next[i] = n+1;
            else next[i] = stw[stn];
            st[++stn] = a[i];
            stw[stn] = i;
        }
    }
    for (int i=1; i<=n; ++i) {
        //printf("%d %d\n", last[i], next[i]);
        long long t = (long long)a[i] * (s[next[i]-1] - s[last[i]]);
        if(t>maxx) {
            maxx=t;
            l=last[i]+1;
            r=next[i]-1;
        }
    }
    cout << maxx << endl;

Read full article from poj 2796 Feel Good(单调队列) - 记录成长的点点滴滴. . . . . - 博客频道 - CSDN.NET

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts